import { IPublicTypeTitleContent, IPublicTypeSetterType, IPublicTypeFieldExtraProps, IPublicTypeFieldConfig, IPublicTypeCustomView, IPublicTypeSetValueOptions } from '@alilc/lowcode-types';
import { Transducer } from './utils';
import { SettingPropEntry } from './setting-prop-entry';
import { SettingEntry } from './setting-entry';
export declare class SettingField extends SettingPropEntry implements SettingEntry {
    readonly isSettingField = true;
    readonly isRequired: boolean;
    readonly transducer: Transducer;
    private _config;
    extraProps: IPublicTypeFieldExtraProps;
    private _title?;
    get title(): IPublicTypeTitleContent;
    private _setter?;
    get setter(): IPublicTypeSetterType | null;
    private _expanded;
    get expanded(): boolean;
    setExpanded(value: boolean): void;
    parent: SettingEntry;
    constructor(parent: SettingEntry, config: IPublicTypeFieldConfig, settingFieldCollector?: (name: string | number, field: SettingField) => void);
    private _items;
    get items(): Array<SettingField | IPublicTypeCustomView>;
    get config(): IPublicTypeFieldConfig;
    private initItems;
    private disposeItems;
    createField(config: IPublicTypeFieldConfig): SettingField;
    purge(): void;
    getConfig<K extends keyof IPublicTypeFieldConfig>(configName?: K): IPublicTypeFieldConfig[K] | IPublicTypeFieldConfig;
    getItems(filter?: (item: SettingField | IPublicTypeCustomView) => boolean): Array<SettingField | IPublicTypeCustomView>;
    private hotValue;
    setValue(val: any, isHotValue?: boolean, force?: boolean, extraOptions?: IPublicTypeSetValueOptions): void;
    getHotValue(): any;
    setMiniAppDataSourceValue(data: any, options?: any): void;
    setHotValue(data: any, options?: IPublicTypeSetValueOptions): void;
    onEffect(action: () => void): () => void;
}
/**
 * @deprecated use same function from '@alilc/lowcode-utils' instead
 */
export declare function isSettingField(obj: any): obj is SettingField;
